/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __grass_DodgeOp_h__
#define __grass_DodgeOp_h__

namespace fe
{

/**************************************************************************//**
	@brief Operator to move curves away from a collider

	@ingroup grass
*//***************************************************************************/
class FE_DL_EXPORT DodgeOp:
	public OperatorThreaded,
	public Initialize<DodgeOp>,
	public ObjectSafe<DodgeOp>
{
	public:

					DodgeOp(void):
						m_frame(-1)											{}

virtual				~DodgeOp(void)											{}

		void		initialize(void);

					//* As HandlerI
virtual	void		handle(Record& a_rSignal);

virtual	void		run(I32 a_id,sp<SurfaceRange> a_spRange);

	private:
		BWORD		hitCheck(SpatialVector a_origin,SpatialVector a_direction,
							Real a_distance,Real a_radius,BWORD a_anyHit,
							sp<DrawI> a_spDebug,BWORD a_guard);

		sp<SurfaceAccessibleI>		m_spInputAccessible;
		sp<SurfaceI>				m_spCollider;
		sp<SurfaceI>				m_spSkin;
		sp<DrawMode>				m_spDebugGroup;
		sp<DrawI>					m_spDrawDebug;

		I32							m_frame;
		Real						m_repulsionScale;

		std::vector<SpatialVector>	m_pointCache;
		std::vector<SpatialVector>	m_lastCache;
		std::vector<BWORD>			m_changedCache;
		I32							m_currentHistory;
};

} /* namespace */

#endif /* __grass_DodgeOp_h__ */

