/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#include "surface/surface.pmh"

namespace fe
{

sp<SurfaceAccessorI> SurfaceAccessibleCatalog::accessor(
	SurfaceAccessibleI::Element a_element,
	String a_name,
	SurfaceAccessibleI::Creation a_create)
{
	sp<SurfaceAccessorCatalog> spAccessor=accessor();
	if(spAccessor.isValid() && spAccessor->bind(a_element,a_name))
	{
		spAccessor->setSurfaceAccessible(sp<SurfaceAccessibleI>(this));
		return spAccessor;
	}
	return sp<SurfaceAccessorI>(NULL);
}

sp<SurfaceAccessorI> SurfaceAccessibleCatalog::accessor(
	SurfaceAccessibleI::Element a_element,
	SurfaceAccessibleI::Attribute a_attribute,
	SurfaceAccessibleI::Creation a_create)
{
	sp<SurfaceAccessorCatalog> spAccessor=accessor();
	if(spAccessor.isValid() && spAccessor->bind(a_element,a_attribute))
	{
		spAccessor->setSurfaceAccessible(sp<SurfaceAccessibleI>(this));
		return spAccessor;
	}
	return sp<SurfaceAccessorI>(NULL);
}

sp<SurfaceAccessorI> SurfaceAccessibleCatalog::accessor(void)
{
	if(!m_spCatalog.isValid())
	{
		return sp<SurfaceAccessorI>(NULL);
	}
	sp<SurfaceAccessorCatalog> spAccessorCatalog(new SurfaceAccessorCatalog());
	if(spAccessorCatalog.isValid())
	{
		spAccessorCatalog->setCatalog(m_spCatalog);

		//* NOTE intentionally duplicating String buffer to be thread safe
		spAccessorCatalog->setKey(m_key.c_str());
	}

	return spAccessorCatalog;
}

BWORD SurfaceAccessibleCatalog::discard(
	SurfaceAccessibleI::Element a_element,String a_name)
{
	//* TODO
	if(!m_spCatalog.isValid())
	{
		return FALSE;
	}

	m_spCatalog->catalogRemove(m_key,a_name);
	return TRUE;
}

} // namespace
